Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3633)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3634)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -1566,5 +1569,7 @@
     CALL cpu_log( log_point(5), 'u-equation', 'start' )
 
+    !$ACC KERNELS PRESENT(tend)
     tend = 0.0_wp
+    !$ACC END KERNELS
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
@@ -1614,4 +1619,8 @@
 !
 !-- Prognostic equation for u-velocity component
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+    !$ACC PRESENT(u, tend, tu_m, u_init, rdf, wall_flags_0) &
+    !$ACC PRESENT(tsc(2:5)) &
+    !$ACC PRESENT(u_p)
     DO  i = nxlu, nxr
        DO  j = nys, nyn
@@ -1640,4 +1649,6 @@
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( intermediate_timestep_count == 1 )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tu_m)
           DO  i = nxlu, nxr
              DO  j = nys, nyn
@@ -1649,4 +1660,6 @@
        ELSEIF ( intermediate_timestep_count < &
                 intermediate_timestep_count_max )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tu_m)
           DO  i = nxlu, nxr
              DO  j = nys, nyn
@@ -1666,5 +1679,7 @@
     CALL cpu_log( log_point(6), 'v-equation', 'start' )
 
+    !$ACC KERNELS PRESENT(tend)
     tend = 0.0_wp
+    !$ACC END KERNELS
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
@@ -1711,4 +1726,8 @@
 !
 !-- Prognostic equation for v-velocity component
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+    !$ACC PRESENT(v, tend, tv_m, v_init, rdf, wall_flags_0) &
+    !$ACC PRESENT(tsc(2:5)) &
+    !$ACC PRESENT(v_p)
     DO  i = nxl, nxr
        DO  j = nysv, nyn
@@ -1737,4 +1756,6 @@
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( intermediate_timestep_count == 1 )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tv_m)
           DO  i = nxl, nxr
              DO  j = nysv, nyn
@@ -1746,4 +1767,6 @@
        ELSEIF ( intermediate_timestep_count < &
                 intermediate_timestep_count_max )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tv_m)
           DO  i = nxl, nxr
              DO  j = nysv, nyn
@@ -1763,5 +1786,7 @@
     CALL cpu_log( log_point(7), 'w-equation', 'start' )
 
+    !$ACC KERNELS PRESENT(tend)
     tend = 0.0_wp
+    !$ACC END KERNELS
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
@@ -1804,4 +1829,8 @@
 !
 !-- Prognostic equation for w-velocity component
+    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+    !$ACC PRESENT(w, tend, tw_m, v_init, rdf, wall_flags_0) &
+    !$ACC PRESENT(tsc(2:5)) &
+    !$ACC PRESENT(w_p)
     DO  i = nxl, nxr
        DO  j = nys, nyn
@@ -1821,4 +1850,6 @@
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( intermediate_timestep_count == 1 )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tw_m)
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -1830,4 +1861,6 @@
        ELSEIF ( intermediate_timestep_count < &
                 intermediate_timestep_count_max )  THEN
+          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+          !$ACC PRESENT(tend, tw_m)
           DO  i = nxl, nxr
              DO  j = nys, nyn
@@ -1868,5 +1901,7 @@
 !--    pt-tendency terms with no communication
        IF ( scalar_advec /= 'bc-scheme' )  THEN
+          !$ACC KERNELS PRESENT(tend)
           tend = 0.0_wp
+          !$ACC END KERNELS
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
@@ -1926,4 +1961,9 @@
 !
 !--    Prognostic equation for potential temperature
+       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+       !$ACC PRESENT(pt, tend, tpt_m, wall_flags_0) &
+       !$ACC PRESENT(pt_init, rdf_sc, ptdf_x, ptdf_y) &
+       !$ACC PRESENT(tsc(3:5)) &
+       !$ACC PRESENT(pt_p)
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1945,4 +1985,6 @@
        IF ( timestep_scheme(1:5) == 'runge' )  THEN
           IF ( intermediate_timestep_count == 1 )  THEN
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+             !$ACC PRESENT(tend, tpt_m)
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -1954,4 +1996,6 @@
           ELSEIF ( intermediate_timestep_count < &
                    intermediate_timestep_count_max )  THEN
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
+             !$ACC PRESENT(tend, tpt_m)
              DO  i = nxl, nxr
                 DO  j = nys, nyn
Index: palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3634)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added routine for calculating near surface air potential temperature (moved
 ! from urban_surface_mod)
@@ -1009,4 +1012,6 @@
        ibit = MERGE( 1, 0, .NOT. downward )
 
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k, w_lfc) &
+       !$ACC PRESENT(surf, u, v)
        DO  m = 1, surf%ns
 
@@ -1297,4 +1302,6 @@
              ELSE
                 !$OMP PARALLEL DO PRIVATE( k, z_mo )
+                !$ACC PARALLEL LOOP PRIVATE(k, z_mo) &
+                !$ACC PRESENT(surf, drho_air_zw)
                 DO  m = 1, surf%ns
 
@@ -1319,4 +1326,7 @@
        IF ( TRIM( most_method ) == 'newton' )  THEN
 
+          !$ACC PARALLEL LOOP PRIVATE(i, j, z_mo) &
+          !$ACC PRIVATE(ol_old, ol_m, ol_l, ol_u, f, f_d_ol) &
+          !$ACC PRESENT(surf)
           DO  m = 1, surf%ns
 
@@ -1575,4 +1585,6 @@
           IF ( .NOT. downward )  THEN
              !$OMP PARALLEL  DO PRIVATE( z_mo )
+             !$ACC PARALLEL LOOP PRIVATE(z_mo) &
+             !$ACC PRESENT(surf)
              DO  m = 1, surf%ns
 
@@ -1591,4 +1603,6 @@
           ELSE
              !$OMP PARALLEL  DO PRIVATE( z_mo )
+             !$ACC PARALLEL LOOP PRIVATE(z_mo) &
+             !$ACC PRESENT(surf)
              DO  m = 1, surf%ns
 
@@ -1605,4 +1619,6 @@
        ELSE
           !$OMP PARALLEL DO PRIVATE( z_mo )
+          !$ACC PARALLEL LOOP PRIVATE(z_mo) &
+          !$ACC PRESENT(surf)
           DO  m = 1, surf%ns
              z_mo = surf%z_mo(m)
@@ -1624,4 +1640,6 @@
 
        !$OMP PARALLEL DO PRIVATE( i, j, k )
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+       !$ACC PRESENT(surf, pt)
        DO  m = 1, surf%ns 
 
@@ -1630,4 +1648,5 @@
           k   = surf%k(m)
 
+#ifndef _OPENACC
           IF ( bulk_cloud_model ) THEN
              surf%pt1(m) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
@@ -1637,9 +1656,13 @@
              surf%qv1(m) = q(k,j,i) 
           ELSE
+#endif
              surf%pt1(m) = pt(k,j,i)
+#ifndef _OPENACC
              IF ( humidity )  THEN
                 surf%qv1(m) = q(k,j,i)
              ELSE
+#endif
                 surf%qv1(m) = 0.0_wp
+#ifndef _OPENACC
              ENDIF
           ENDIF 
@@ -1648,4 +1671,5 @@
              surf%vpt1(m) = pt(k,j,i) * ( 1.0_wp + 0.61_wp * q(k,j,i) )
           ENDIF
+#endif
           
        ENDDO
@@ -1658,4 +1682,53 @@
 !-- ( only for upward-facing surfs )
     SUBROUTINE calc_pt_surface
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  k_off    !< index offset between surface and atmosphere grid point (-1 for upward-, +1 for downward-facing walls) 
+       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
+       
+       k_off = surf%koff
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+       !$ACC PRESENT(surf, pt)
+       DO  m = 1, surf%ns 
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+
+          surf%pt_surface(m) = pt(k+k_off,j,i)
+
+       ENDDO
+
+    END SUBROUTINE calc_pt_surface
+
+!
+!-- Set mixing ratio at surface grid level. ( Only for upward-facing surfs. )
+    SUBROUTINE calc_q_surface
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  k_off   !< index offset between surface and atmosphere grid point (-1 for upward-, +1 for downward-facing walls) 
+       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
+       
+       k_off = surf%koff
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       DO  m = 1, surf%ns 
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+
+          surf%q_surface(m) = q(k+k_off,j,i)
+
+       ENDDO
+
+    END SUBROUTINE calc_q_surface
+    
+!
+!-- Set virtual potential temperature at surface grid level.
+!-- ( only for upward-facing surfs )
+    SUBROUTINE calc_vpt_surface
 
        IMPLICIT NONE
@@ -1672,51 +1745,4 @@
           k   = surf%k(m)
 
-          surf%pt_surface(m) = pt(k+k_off,j,i)
-
-       ENDDO
-
-    END SUBROUTINE calc_pt_surface
-
-!
-!-- Set mixing ratio at surface grid level. ( Only for upward-facing surfs. )
-    SUBROUTINE calc_q_surface
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  k_off   !< index offset between surface and atmosphere grid point (-1 for upward-, +1 for downward-facing walls) 
-       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
-       
-       k_off = surf%koff
-       !$OMP PARALLEL DO PRIVATE( i, j, k )
-       DO  m = 1, surf%ns 
-
-          i   = surf%i(m)            
-          j   = surf%j(m)
-          k   = surf%k(m)
-
-          surf%q_surface(m) = q(k+k_off,j,i)
-
-       ENDDO
-
-    END SUBROUTINE calc_q_surface
-    
-!
-!-- Set virtual potential temperature at surface grid level.
-!-- ( only for upward-facing surfs )
-    SUBROUTINE calc_vpt_surface
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  k_off    !< index offset between surface and atmosphere grid point (-1 for upward-, +1 for downward-facing walls) 
-       INTEGER(iwp) ::  m       !< loop variable over all horizontal surf elements 
-       
-       k_off = surf%koff
-       !$OMP PARALLEL DO PRIVATE( i, j, k )
-       DO  m = 1, surf%ns 
-
-          i   = surf%i(m)            
-          j   = surf%j(m)
-          k   = surf%k(m)
-
           surf%vpt_surface(m) = vpt(k+k_off,j,i)
 
@@ -1741,4 +1767,6 @@
 
           !$OMP PARALLEL DO PRIVATE( i, j, k )
+          !$ACC PARALLEL LOOP PRIVATE(i, j, k) &
+          !$ACC PRESENT(surf, drho_air_zw)
           DO  m = 1, surf%ns 
 
@@ -2039,4 +2067,6 @@
           IF ( .NOT. downward )  THEN
              !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             !$ACC PARALLEL LOOP PRIVATE(i, j, k, z_mo) &
+             !$ACC PRESENT(surf, u, rho_air_zw)
              DO  m = 1, surf%ns  
    
@@ -2086,4 +2116,6 @@
           IF ( .NOT. downward )  THEN
              !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             !$ACC PARALLEL LOOP PRIVATE(i, j, k, z_mo) &
+             !$ACC PRESENT(surf, v, rho_air_zw)
              DO  m = 1, surf%ns  
                 i = surf%i(m)            
@@ -2392,4 +2424,5 @@
 !-- Integrated stability function for momentum
     FUNCTION psi_m( zeta ) 
+       !$ACC ROUTINE SEQ
        
        USE kinds
@@ -2429,4 +2462,5 @@
 !-- Integrated stability function for heat and moisture
     FUNCTION psi_h( zeta ) 
+       !$ACC ROUTINE SEQ
        
        USE kinds
@@ -2469,4 +2503,5 @@
 !------------------------------------------------------------------------------!
     FUNCTION phi_m( zeta ) 
+       !$ACC ROUTINE SEQ
    
        IMPLICIT NONE 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 3633)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 3634)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! OpenACC port for SPEC
+! 
+! 3597 2018-12-04 08:40:18Z maronga
 ! Added pt_2m and renamed t_surf_10cm to pt_10cm. Removed some _eb variables as
 ! they are no longer used.
@@ -608,4 +611,12 @@
     END INTERFACE init_surface_arrays
 
+    INTERFACE enter_surface_arrays
+       MODULE PROCEDURE enter_surface_arrays
+    END INTERFACE
+
+    INTERFACE exit_surface_arrays
+       MODULE PROCEDURE exit_surface_arrays
+    END INTERFACE
+
     INTERFACE surface_rrd_local
        MODULE PROCEDURE surface_rrd_local
@@ -634,6 +645,7 @@
 !-- Public subroutines and functions
     PUBLIC get_topography_top_index, get_topography_top_index_ji, init_bc,     &
-           init_surfaces, init_surface_arrays, surface_rrd_local,              & 
-           surface_restore_elements, surface_wrd_local, surface_last_actions
+           init_surfaces, init_surface_arrays, enter_surface_arrays,           &
+           exit_surface_arrays, surface_rrd_local, surface_restore_elements,   &
+           surface_wrd_local, surface_last_actions
 
 
@@ -1084,4 +1096,92 @@
 
     END SUBROUTINE init_surface_arrays
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Enter horizontal and vertical surfaces.
+!------------------------------------------------------------------------------!
+    SUBROUTINE enter_surface_arrays
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  l     !<
+       
+       !$ACC ENTER DATA &
+       !$ACC COPYIN(surf_def_h(0:2)) &
+       !$ACC COPYIN(surf_def_v(0:3)) &
+       !$ACC COPYIN(surf_lsm_h) &
+       !$ACC COPYIN(surf_lsm_v(0:3)) &
+       !$ACC COPYIN(surf_usm_h) &
+       !$ACC COPYIN(surf_usm_v(0:3))
+
+       ! Copy data in surf_def_h(0:2)
+       DO  l = 0, 1
+          CALL enter_surface_attributes_h(surf_def_h(l))
+       ENDDO
+       CALL enter_surface_attributes_h_top(surf_def_h(2))
+       ! Copy data in surf_def_v(0:3)
+       DO  l = 0, 3
+          CALL enter_surface_attributes_v(surf_def_v(l))
+       ENDDO
+       ! Copy data in surf_lsm_h
+       CALL enter_surface_attributes_h(surf_lsm_h)
+       ! Copy data in surf_lsm_v(0:3)
+       DO  l = 0, 3
+          CALL enter_surface_attributes_v(surf_lsm_v(l))
+       ENDDO
+       ! Copy data in surf_usm_h
+       CALL enter_surface_attributes_h(surf_usm_h)
+       ! Copy data in surf_usm_v(0:3)
+       DO  l = 0, 3
+          CALL enter_surface_attributes_v(surf_usm_v(l))
+       ENDDO
+
+    END SUBROUTINE enter_surface_arrays
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Exit horizontal and vertical surfaces.
+!------------------------------------------------------------------------------!
+    SUBROUTINE exit_surface_arrays
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  l     !<
+       
+       ! Delete data in surf_def_h(0:2)
+       DO  l = 0, 1
+          CALL exit_surface_attributes_h(surf_def_h(l))
+       ENDDO
+       CALL exit_surface_attributes_h(surf_def_h(2))
+       ! Delete data in surf_def_v(0:3)
+       DO  l = 0, 3
+          CALL exit_surface_attributes_v(surf_def_v(l))
+       ENDDO
+       ! Delete data in surf_lsm_h
+       CALL exit_surface_attributes_h(surf_lsm_h)
+       ! Delete data in surf_lsm_v(0:3)
+       DO  l = 0, 3
+          CALL exit_surface_attributes_v(surf_lsm_v(l))
+       ENDDO
+       ! Delete data in surf_usm_h
+       CALL exit_surface_attributes_h(surf_usm_h)
+       ! Delete data in surf_usm_v(0:3)
+       DO  l = 0, 3
+          CALL exit_surface_attributes_v(surf_usm_v(l))
+       ENDDO
+
+       !$ACC EXIT DATA &
+       !$ACC DELETE(surf_def_h(0:2)) &
+       !$ACC DELETE(surf_def_v(0:3)) &
+       !$ACC DELETE(surf_lsm_h) &
+       !$ACC DELETE(surf_lsm_v(0:3)) &
+       !$ACC DELETE(surf_usm_h) &
+       !$ACC DELETE(surf_usm_v(0:3))
+
+    END SUBROUTINE exit_surface_arrays
 
 
@@ -1328,4 +1428,86 @@
 ! Description:
 ! ------------
+!> Exit memory for upward and downward-facing horizontal surface types,
+!> except for top fluxes.
+!------------------------------------------------------------------------------!
+    SUBROUTINE exit_surface_attributes_h( surfaces )
+
+       IMPLICIT NONE
+   
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+   
+       !$ACC EXIT DATA &
+       !$ACC DELETE(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%i(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%j(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%k(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%z_mo(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%uvw_abs(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%z0(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%us(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%ol(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%rib(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%usws(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%vsws(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%ts(1:surfaces%ns)) &
+       !$ACC COPYOUT(surfaces%shf(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%pt_surface(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%pt1(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%qv1(1:surfaces%ns))
+
+       IF ( .NOT. constant_diffusion )  THEN
+          !$ACC EXIT DATA &
+          !$ACC DELETE(surfaces%u_0(1:surfaces%ns)) &
+          !$ACC DELETE(surfaces%v_0(1:surfaces%ns))
+       ENDIF
+   
+    END SUBROUTINE exit_surface_attributes_h
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Enter memory for upward and downward-facing horizontal surface types,
+!> except for top fluxes.
+!------------------------------------------------------------------------------!
+    SUBROUTINE enter_surface_attributes_h( surfaces )
+
+       IMPLICIT NONE
+
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+
+       !$ACC ENTER DATA &
+       !$ACC COPYIN(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%i(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%j(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%k(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%z_mo(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%uvw_abs(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%z0(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%us(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%ol(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%rib(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%usws(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%vsws(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%ts(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%shf(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%pt1(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%qv1(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%pt_surface(1:surfaces%ns))
+
+       IF ( .NOT. constant_diffusion )  THEN
+          !$ACC ENTER DATA &
+          !$ACC COPYIN(surfaces%u_0(1:surfaces%ns)) &
+          !$ACC COPYIN(surfaces%v_0(1:surfaces%ns))
+       ENDIF
+
+    END SUBROUTINE enter_surface_attributes_h
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Deallocating memory for model-top fluxes  
 !------------------------------------------------------------------------------!
@@ -1460,4 +1642,64 @@
 
     END SUBROUTINE allocate_surface_attributes_h_top
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Exit memory for model-top fluxes.
+!------------------------------------------------------------------------------!
+    SUBROUTINE exit_surface_attributes_h_top( surfaces )
+
+       IMPLICIT NONE
+   
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+   
+       !$ACC EXIT DATA &
+       !$ACC DELETE(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%i(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%j(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%k(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%usws(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%vsws(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%shf(1:surfaces%ns))
+
+       IF ( .NOT. constant_diffusion )  THEN
+          !$ACC EXIT DATA &
+          !$ACC DELETE(surfaces%u_0(1:surfaces%ns)) &
+          !$ACC DELETE(surfaces%v_0(1:surfaces%ns))
+       ENDIF
+   
+    END SUBROUTINE exit_surface_attributes_h_top
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Enter memory for model-top fluxes.
+!------------------------------------------------------------------------------!
+    SUBROUTINE enter_surface_attributes_h_top( surfaces )
+
+       IMPLICIT NONE
+
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+
+       !$ACC ENTER DATA &
+       !$ACC COPYIN(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%i(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%j(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%k(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%usws(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%vsws(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%shf(1:surfaces%ns))
+
+       IF ( .NOT. constant_diffusion )  THEN
+          !$ACC ENTER DATA &
+          !$ACC COPYIN(surfaces%u_0(1:surfaces%ns)) &
+          !$ACC COPYIN(surfaces%v_0(1:surfaces%ns))
+       ENDIF
+
+    END SUBROUTINE enter_surface_attributes_h_top
 
 
@@ -1703,4 +1945,66 @@
 
     END SUBROUTINE allocate_surface_attributes_v
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Exit memory for vertical surface types. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE exit_surface_attributes_v( surfaces )
+
+       IMPLICIT NONE
+
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+
+       !$ACC EXIT DATA &
+       !$ACC DELETE(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC DELETE(surfaces%i(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%j(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%k(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%uvw_abs(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%z0(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%rib(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%mom_flux_uv(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%mom_flux_w(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%mom_flux_tke(0:1,1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%ts(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%shf(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%pt1(1:surfaces%ns)) &
+       !$ACC DELETE(surfaces%qv1(1:surfaces%ns))
+
+    END SUBROUTINE exit_surface_attributes_v
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Enter memory for vertical surface types. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE enter_surface_attributes_v( surfaces )
+   
+       IMPLICIT NONE
+   
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+   
+       !$ACC ENTER DATA &
+       !$ACC COPYIN(surfaces%start_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%end_index(nys:nyn,nxl:nxr)) &
+       !$ACC COPYIN(surfaces%i(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%j(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%k(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%uvw_abs(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%z0(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%rib(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%mom_flux_uv(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%mom_flux_w(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%mom_flux_tke(0:1,1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%ts(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%shf(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%pt1(1:surfaces%ns)) &
+       !$ACC COPYIN(surfaces%qv1(1:surfaces%ns))
+   
+    END SUBROUTINE enter_surface_attributes_v
 
 
